<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import QRCodeStyling from 'qr-code-styling';
import { ref, onMounted, inject } from 'vue';
import { useI18n } from 'vue-i18n';
import { useMetaStore } from '@/stores/meta';
import Modal from '@/components/general/Modal.vue';
import { request } from '@/lib/request';
import Button from '@/components/general/Button.vue';
import { Disclosure, DisclosureButton, DisclosurePanel } from '@headlessui/vue';
import { useBaseStore } from '@/stores/base';
import { adminMenuEnum } from '@/enums/enums';


const { t } = useI18n();
const $t = t;

const props = defineProps<{
    modelValue?: boolean
}>();

const emits = defineEmits<{
    //(e: 'update:modelValue', value: boolean): void
    (e: 'close', value: boolean): void
}>();

let configuration = inject<any>('configuration');
const store = useMetaStore();
const baseStore = useBaseStore();
const { noPassHash, hashcode, openMenu } = storeToRefs(store);
const { message } = storeToRefs(baseStore);
const baseURL = configuration.baseURL;
const basePath = configuration.basePath;
const qrstyling = configuration.style.qrcode;

const noPassLink = ref(baseURL + basePath + "pl/" + noPassHash.value);
const qrcodeColors = qrstyling;

const currentURL = ref(baseURL + basePath + hashcode.value);
const modURL = ref(baseURL + basePath + "t/" + hashcode.value);
const src = noPassLink.value + "?frame=1";
const iframe = "<iframe frameborder='0' src='" + src + "' style='width:100%;height:600px;padding:0;margin:0;'></iframe>";

const copyCode = () => {
    navigator.clipboard.writeText(iframe).then(() => {
        message.value = $t('adminMenu.pageShare.copy.success.html');
    }).catch((e) => { console.error(e) });
};

const qrcodeRef = ref();
const qrcodeModRef = ref();

const moderatorPasswordSet = ref(true);

onMounted(async () => {
    setTimeout(async () => {
        const options = {
            width: 250,
            height: 250,
            type: 'canvas',
            data: noPassLink.value,
            image: basePath + 'images/logo_qr.png',
            margin: 10,
            qrOptions: {
                typeNumber: 0,
                mode: 'Byte',
                errorCorrectionLevel: 'Q'
            },
            imageOptions: {
                hideBackgroundDots: false,
                imageSize: 0.4,
                margin: 5,
                crossOrigin: 'anonymous',
            },
            dotsOptions: {
                color: qrcodeColors.dots,
                type: 'rounded'
            },
            backgroundOptions: {
                color: qrcodeColors.background,
            },
            cornersSquareOptions: {
                color: qrcodeColors.cornersSquare,
                type: 'extra-rounded',
            },
            cornersDotOptions: {
                color: qrcodeColors.cornersDot,
                //type: 'none',
            }
        };
        qrcodeRef.value.innerHTML = null;
        //@ts-ignore
        const qrCode = new QRCodeStyling(options);
        qrCode.append(qrcodeRef.value);

        const result = (await request('GET', `${configuration.apiServer}/api/pane/${hashcode.value}/moderation`)).success;
        if (result) {
            moderatorPasswordSet.value = true;
            const optionsModQR = {
                width: 250,
                height: 250,
                type: 'canvas',
                data: modURL.value,
                image: basePath + 'images/logo_qr.png',
                margin: 10,
                qrOptions: {
                    typeNumber: 0,
                    mode: 'Byte',
                    errorCorrectionLevel: 'Q'
                },
                imageOptions: {
                    hideBackgroundDots: false,
                    imageSize: 0.4,
                    margin: 5,
                    crossOrigin: 'anonymous',
                },
                dotsOptions: {
                    color: qrcodeColors.dots,
                    type: 'rounded'
                },
                backgroundOptions: {
                    color: qrcodeColors.background,
                },
                cornersSquareOptions: {
                    color: qrcodeColors.cornersSquare,
                    type: 'extra-rounded',
                },
                cornersDotOptions: {
                    color: qrcodeColors.cornersDot,
                    //type: 'none',
                }
            };
            qrcodeModRef.value.innerHTML = null;
            //@ts-ignore
            const qrCodeMod = new QRCodeStyling(optionsModQR);
            qrCodeMod.append(qrcodeModRef.value);

        }
        else
            moderatorPasswordSet.value = false;
    }, 1);
});

const closeModal = () => {
    openMenu.value = adminMenuEnum.NONE;
    //emits('close', false);
}

const firstAccordionItemOpen = ref(true);
const handleToggleAccordionItem = (() => {
    firstAccordionItemOpen.value = !firstAccordionItemOpen.value;
});

</script>
<template>
    <Modal :header="$t('adminMenu.pageShare.title') + ' ' + $t('general.variables.with')"
        :labelSubmit="$t('general.buttons.close')" @submit="closeModal">
        <div class="text-gray-700 flex flex-col gap-2">
            <Disclosure>
                <DisclosureButton class="w-full text-left text-lg hover:bg-gray-100 rounded-md px-2 py-1"
                    @click="handleToggleAccordionItem">
                    {{ $t('indexPage.buttonTexts.login.tabs.user') }}
                    <i :class="`ri-arrow-${firstAccordionItemOpen ? 'up' : 'down'}-s-line`"></i>
                </DisclosureButton>
                <transition name="expand">
                    <DisclosurePanel static v-show="firstAccordionItemOpen">
                        <div class="flex flex-row gap-2">
                            <div>
                                <div class="z-[2000]" id="qrcode" ref="qrcodeRef"></div>
                            </div>
                            <div class="w-full sm:w-1/2">
                                <h4 class="text-lg">{{ $t('indexPage.buttonTexts.login.input') }}:</h4>
                                <h5 class="text-gray-500 break-all">{{ hashcode }}</h5>
                                <h4 class="mt-2 text-lg">{{ $t('adminMenu.pageShare.link.withPassword') }}:</h4>
                                <h5 class="text-gray-500 break-all">{{ currentURL }}</h5>
                                <h4 class="mt-2 text-lg">{{ $t('adminMenu.pageShare.link.withoutPassword') }}:</h4>
                                <h5 class="text-gray-500 break-all">{{ noPassLink }}</h5>
                            </div>
                        </div>
                        <h4 class="mt-4 text-lg">{{ $t('adminMenu.pageShare.iframeLabel') }}:</h4>
                        <pre
                            class="mb-2 whitespace-pre-line p-3 bg-white overflow-auto text-gray-700 font-mono border border-gray-300">
                        <code class="whitespace-pre-wrap">{{ iframe }}</code>
                    </pre>
                        <Button variant="confirm" @click="copyCode()">
                            <i class="ri-file-copy-line"></i>
                            <span class="ml-2">{{ $t('adminMenu.pageShare.copy.label') }}</span>
                        </Button>
                    </DisclosurePanel>
                </transition>
            </Disclosure>
            <Disclosure>
                <DisclosureButton class="w-full text-left text-lg hover:bg-gray-100 rounded-md px-2 py-1"
                    @click="handleToggleAccordionItem">
                    {{ $t('indexPage.buttonTexts.login.tabs.mod') }}
                    <i :class="`ri-arrow-${!firstAccordionItemOpen ? 'up' : 'down'}-s-line`"></i>
                </DisclosureButton>
                <transition name="expand-mod">
                    <DisclosurePanel static v-show="!firstAccordionItemOpen">
                        <div class="flex flex-row gap-2" v-if="moderatorPasswordSet">
                            <div>
                                <div class="z-[2000]" id="qrcode_mod" ref="qrcodeModRef"></div>
                            </div>
                            <div class="w-full sm:w-1/2">
                                <h4 class="text-lg">{{ $t('adminMenu.pageShare.link.mod') }}:</h4>
                                <h5 class="text-gray-500">{{ modURL }}</h5>
                            </div>
                        </div>
                        <div v-else>{{ $t('general.errors.noModPassword') }}</div>
                    </DisclosurePanel>
                </transition>
            </Disclosure>
        </div>
    </Modal>
</template>

<style scoped>
.expand-enter-active {
    transition: all 0.5s cubic-bezier(1, 0.9, 0.3, 1);
    overflow: hidden;
    max-height: 0px;
    padding-top: 0px;
    padding-bottom: 0px;

}

.expand-leave-active {
    transition: all 0.5s cubic-bezier(1, 0.9, 0.3, 1);
    overflow: hidden;
    max-height: 0px;
    padding-top: 0px;
    padding-bottom: 0px;
}

.expand-enter,
.expand-leave-to {
    max-height: 0px;
    overflow: hidden;
    padding-top: 0px;
    padding-top: 0px;
    padding-bottom: 0px;

}


.expand-enter-from {
    max-height: 0px;
    overflow: hidden;padding-top: 0px;
    padding-bottom: 0px;
}

.expand-enter-to {
    max-height: 500px;
    overflow: hidden;
    padding-top: 0px;
    padding-bottom: 0px;
}

.expand-leave {
    max-height: 500px;
    padding-top: 0px;
    padding-bottom: 0px;
}

.expand-leave-from {
    max-height: 500px;
    padding-top: 0px;
    padding-bottom: 0px;
}



.expand-mod-enter-active {
    transition: all 0.5s cubic-bezier(1, 0.9, 0.3, 1);
    overflow: hidden;
    max-height: 0px;
    padding-top: 0px;
    padding-bottom: 0px;
}

.expand-mod-leave-active {
    transition: all 0.5s cubic-bezier(1, 0.9, 0.3, 1);
    overflow: hidden;
    max-height: 0px;
    padding-top: 0px;
    padding-bottom: 0px; 

}

.expand-mod-enter,
.expand-mod-leave-to {
    max-height: 0px;
    overflow: hidden;
    padding-top: 0px;
    padding-bottom: 0px;

}


.expand-mod-enter-from {
    max-height: 0px;
    overflow: hidden;
}

.expand-mod-enter-to {
    max-height: 250px;
    overflow: hidden;
    padding-top: 0px;
    padding-bottom: 0px;
}

.expand-mod-leave {
    max-height: 250px;
    padding-top: 0px;
    padding-bottom: 0px;
}

.expand-mod-leave-from {
    max-height: 250px;
    padding-top: 0px;
    padding-bottom: 0px;
}
</style>